import java.sql.*;
import java.util.Properties;
import java.io.InputStream;

public class Comments {
  public static void main (String args[]) {
    String driverPrefixURL = "jdbc:odbc:";
    String username = null;
    String password = null;
    String dataSource = null;
    try {
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    }
    catch (Exception e) {
      System.out.println("Failed to load JDBC/ODBC driver.");
      return;
    }
    try {
      // Look for resource file 'odbc.datasource'
      InputStream is = ClassLoader.getSystemResourceAsStream ("odbc.datasource");
      Properties p = new Properties();
      p.load (is);
      dataSource = p.getProperty("datasource.name");
      if (dataSource == null)
        throw new Exception ();
      username = p.getProperty("datasource.username", "");
      password = p.getProperty("datasource.password", "");
    } catch (Exception e) {
      System.out.println("Unable to read resource to get data source");
      return;
    }
    try {
      Connection con = DriverManager.getConnection(driverPrefixURL+dataSource, username, password);
      if (args.length == 0) { // Query
        Statement statement = con.createStatement();
        ResultSet result = statement.executeQuery("SELECT * FROM comments");
        System.out.println("Name\tEmail\tComments");
        int nameCol = result.findColumn ("name");
        int userCol = result.findColumn ("username");
        int commentsCol = result.findColumn ("comments");
        String name, user, comments;
        while(result.next()) {
          name = result.getString(nameCol);
          user = result.getString(userCol);
          comments = result.getString(commentsCol);
          System.out.println (name + "\t" + user + "\t" + comments);
        }
        statement.close();
      } else {
        PreparedStatement prep = con.prepareStatement("INSERT into comments values (?, ?, ?)");
        for (int i=0;i+3<=args.length;i+=3) {
           prep.setString (1, args[i]);
           prep.setString (2, args[i+1]);
           prep.setString (3, args[i+2]);
           if (prep.executeUpdate () != 1)
             throw new Exception ("Bad Update");
        }
      }
      con.close();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
}

