import java.sql.*;
import java.util.Properties;
import java.io.InputStream;

public class ConnectMe  {
  public static void main (String args[]) {
    String driverPrefixURL = "jdbc:odbc:";
    String username = null;
    String password = null;
    String dataSource = null;
    try {
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    } catch (Exception e) {
      System.out.println("Failed to load JDBC/ODBC driver.");
      return;
    }
    try {
      // Look for resource file 'odbc.datasource'
      InputStream is = ClassLoader.getSystemResourceAsStream ("odbc.datasource");
      Properties p = new Properties();
      p.load (is);
      dataSource = p.getProperty("datasource.name");
      if (dataSource == null)
        throw new Exception ();
      username = p.getProperty("datasource.username", "");
      password = p.getProperty("datasource.password", "");
    } catch (Exception e) {
      System.out.println("Unable to read resource to get data source");
      return;
    }
    try {
      Connection con = DriverManager.getConnection(driverPrefixURL+dataSource, username, password);
      System.out.println("Connected.");
      DatabaseMetaData dmd = con.getMetaData();
      if (dmd == null) {
        System.out.println ("No Database Meta Data");
      } else {
        System.out.println ("Database Product Name   : " + dmd.getDatabaseProductName());
        System.out.println ("Database Product Version: " + dmd.getDatabaseProductVersion());
        System.out.println ("Database Driver Name    : " + dmd.getDriverName());
        System.out.println ("Database Driver Version : " + dmd.getDriverVersion());
      }
      con.close();
    }
    catch( Exception e ) {
      e.printStackTrace();
    }
  }
}

