import java.sql.*;
import java.util.Properties;
import java.io.InputStream;

public class TellmeStuff {
  public static void main (String args[]) {
    String driverPrefixURL = "jdbc:odbc:";
    String username = null;
    String password = null;
    String dataSource = null;
    try {
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    }
    catch (Exception e) {
      System.out.println("Failed to load JDBC/ODBC driver.");
      return;
    }
    try {
      // Look for resource file 'odbc.datasource'
      InputStream is = ClassLoader.getSystemResourceAsStream ("odbc.datasource");
      Properties p = new Properties();
      p.load (is);
      dataSource = p.getProperty("datasource.name");
      if (dataSource == null)
        throw new Exception ();
      username = p.getProperty("datasource.username", "");
      password = p.getProperty("datasource.password", "");
    } catch (Exception e) {
      System.out.println("Unable to read resource to get data source");
      return;
    }
    try {
      Connection con = DriverManager.getConnection(driverPrefixURL+dataSource, username, password);
      Statement select = con.createStatement();
      ResultSet result = select.executeQuery("SELECT * FROM instructors");
      ResultSetMetaData meta = result.getMetaData();

      int nullCount = 0;
      int numbers = 0;
      int columns = meta.getColumnCount();
      for (int i=1;i<=columns;i++) {
        System.out.println (meta.getColumnLabel(i) + "\t"
                          + meta.getColumnTypeName(i));

        if (meta.isNullable(i) == ResultSetMetaData.columnNullable)
          nullCount++;
        if (meta.isSigned(i))
          numbers++;
      }
      System.out.println ("Columns: " + columns + " Nullable: " + nullCount + " Numeric: " + numbers);

      select.close();
      con.close();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
}
