import java.awt.*;

import java.util.Properties;
import java.io.InputStream;

public class Grades {
  private static NFBarchartApp bar;

  public static void main (String args[]) {
    String driverPrefixURL = "jdbc:odbc:";
    String username = null;
    String password = null;
    String dataSource = null;
    try {
      // Load Driver
    } catch (Exception e) {
      System.out.println("Failed to load JDBC/ODBC driver.");
      return;
    }
    try {
      // Look for resource file 'odbc.datasource'
      InputStream is = ClassLoader.getSystemResourceAsStream ("odbc.datasource");
      Properties p = new Properties();
      p.load (is);
      dataSource = p.getProperty("datasource.name");
      if (dataSource == null)
        throw new Exception ();
      username = p.getProperty("datasource.username", "");
      password = p.getProperty("datasource.password", "");
    } catch (Exception e) {
      System.out.println("Unable to read resource to get data source");
      return;
    }
    try {
      // Create connection
      // Create statement
      // Execute Query, get back result set
      
      // Find each column number
      // Find 'name'
      // Find 'grade'

      // Variables for graphing
      StringBuffer names = new StringBuffer();
      StringBuffer averages = new StringBuffer();

      // Loop through each record
      while() {

      }


      // Close Statement
      // Close Connection
      // When done display chart on Frame.
      // After closing connection
      if (names.length() != 0) {
        Frame f = new Frame ("Graph");
        showChartData (names.toString(), averages.toString());
        f.add(bar, BorderLayout.CENTER);
        f.setSize (300, 300);
        f.show();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  private static float convertGrade (String grade) {
    String trimmedGrade = grade.trim();
    float returnValue = 0;
    if (trimmedGrade.equals ("A"))
      returnValue = 4.0f;
    else if (trimmedGrade.equals ("A-"))
      returnValue = 3.667f;
    else if (trimmedGrade.equals ("B+"))
      returnValue = 3.333f;
    else if (trimmedGrade.equals ("B"))
      returnValue = 3.0f;
    else if (trimmedGrade.equals ("B-"))
      returnValue = 2.667f;
    else if (trimmedGrade.equals ("C+"))
      returnValue = 2.333f;
    else if (trimmedGrade.equals ("C"))
      returnValue = 2.0f;
    else if (trimmedGrade.equals ("C-"))
      returnValue = 1.667f;
    else if (trimmedGrade.equals ("D+"))
      returnValue = 1.333f;
    else if (trimmedGrade.equals ("D"))
      returnValue = 1.0f;
    else if (trimmedGrade.equals ("D-"))
      returnValue = 0.667f;
    return returnValue;
  }
  private static void showChartData (String names, String averages) {
    try {
      bar = new NFBarchartApp ();
      bar.init();
      bar.start();
      bar.loadParams ("Header      = ('Grade Report');" +
                      "HeaderBox   = (blue, SHADOW, 4);" +
                      "DataSets    = ('Grades', yellow);" +
                      "DataSet1    = "+ averages + ";" +
                      "BarLabels   = "+ names    + ";" +
                      "GraphLayout = VERTICAL;" +
                      "BottomAxis  = (green, 'TimesRoman', 14, 0, 0, 4)"
                     );
      bar.loadParams ("Update");
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}
